import * as Knex from "knex";
import { IDatabaseSchema } from "./mysql-database-definition";
export default class ModelBuilder {
    private knex;
    private databaseName;
    static init(knex: Knex): Promise<IDatabaseSchema>;
    /**
     * Return a copy of an object but with all keys lower case
     */
    private static keysToLower<T>(obj);
    /**
     * Return the length of a type, eg varchar(255)=>255
     * @param type
     */
    private static getMysqlLength(strType);
    /**
     * Return the length of a type, eg varchar(255)=>varchar
     * @param type
     */
    private static stripMysqlLength(type);
    constructor(knex: Knex, databaseName?: string);
    renderDatabaseSchema(): Promise<IDatabaseSchema>;
    private getDatabaseName();
    /**
     * return a select query to list all tables or views from a database
     */
    private listFromDatabase(listType);
    private listViews();
    /**
     * Lists all the tables in current database
     */
    private listTables();
    private columnArrayToDatabaseSchema(colArrMap);
    /**
     * List all columns for a table given table name
     */
    private listColumns(tableName);
    private renderModel(tables);
    private listStoredProcedures();
    private listStoredProcedureParams();
    private renderStoredProcedures();
    private renderViewModel();
    private renderTableModel();
}
