import * as Knex from "knex";
import { ISetting } from "./isetting";
import { IDatabaseSchema } from "./mysql-database-definition";
export default class TsBuilder {
    private schema;
    static init(knex: Knex, folder: string): Promise<TsBuilder>;
    static runDefault(knex: Knex, folder: string): Promise<void>;
    private static normFolder(folder);
    readonly mysqlTypes: {
        blob: string;
        bigint: string;
        char: string;
        date: string;
        datetime: string;
        decimal: string;
        double: string;
        float: string;
        int: string;
        longblob: string;
        longtext: string;
        mediumtext: string;
        set: string;
        smallint: string;
        text: string;
        timestamp: string;
        tinyint: string;
        varchar: string;
    };
    settings: ISetting;
    private folder;
    constructor(folder: string, schema?: IDatabaseSchema);
    getTypeMap(): Map<string, string>;
    init(knex: Knex, dbName?: string): Promise<TsBuilder>;
    renderDefault(): void;
    private intefaceFullPath();
    private graphQlFullPath();
    private renderTableFile();
    private renderViewFile();
    private renderColumnsFile();
    private renderGraphQlFiles();
    private renderClassFiles();
    private renderViewClassFiles();
    private renderInserter();
    private renderGetter();
    private renderSchemaOperator();
    private renderStoredProcedure();
    private renderAbstractHandler();
    private getMetaText();
    private renderClasses(tables, folder, isTable);
    private listTables();
    private listViews();
    private getClassName(tableName);
    private getPrefixedClassName(tableName);
    private getFilenameEnding();
    private toFilename(name);
}
