"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Knex = require("knex");
class Database {
    static getOptions() {
        return this.getInstance().getOptions();
    }
    static getKnexInstance() {
        return this.getInstance().knex;
    }
    static getDatabaseName() {
        return this.getInstance().schema;
    }
    static shutdown() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.instance) {
                yield this.instance.close();
                this.instance = undefined;
            }
        });
    }
    static getInstance() {
        if (!Database.instance) {
            Database.instance = new Database();
            Database.instance.init();
        }
        return Database.instance;
    }
    constructor() {
        console.log("Creating db");
        this.schema = "SkolvalEdge";
    }
    getOptions() {
        return {
            database: this.schema,
            host: "skolval.cbzxws8hjvxc.eu-west-1.rds.amazonaws.com",
            password: "ujqtwrtbdtptjqyu",
            port: 3306,
            timezone: "utc",
            user: "backend"
        };
    }
    close() {
        return __awaiter(this, void 0, void 0, function* () {
            yield new Promise((resolve) => {
                this.knex.destroy(() => {
                    resolve();
                });
            });
        });
    }
    init() {
        this.renderKnex();
    }
    renderKnex() {
        this.knex = Knex({
            client: "mysql",
            connection: this.getOptions(),
            pool: {
                max: 100,
                min: 0
            }
        });
    }
}
exports.Database = Database;
//# sourceMappingURL=database.js.map